% See impr3 for functions and changes
% help impr4

clear all
close all
% ImLightOffName=input('filename of image no light > ')
% ImLightOnName=input('filename of image WITH light > ')
% ImLightOffName='picture 3.jpg'

ImLightOnName = 'picture 7.jpg' % concrete
%ImLightOnName = 'picture 8.jpg' % sandpaper
% ImLightOnName = 'picture 9.jpg' % holes

% ImLightOff = imread(ImLightOffName);
%ImLightOn = double(imread(ImLightOnName));
ImLightOn = imread(ImLightOnName);
ImRedLight = ImLightOn;
ImBlueLight = ImLightOn;

% ImLightOff=double(ImLightOff);
ImLightOn=double(ImLightOn);
[Rows, Columns, k]=size(ImLightOn);

%for i=1:Rows
%    for j=1:Columns/3
%    ImDiff(i,j) = single(ImLightOn(i,j))-single(ImLightOff(i,j));


ImDiff(:,:,1) = ImLightOn(:,:,3)-ImLightOn(:,:,2); % B-G
    ImDiff(:,:,2) = ImLightOn(:,:,2)-ImLightOn(:,:,3); % G-B for verification
ImDiff(:,:,3) = ImLightOn(:,:,1)-ImLightOn(:,:,2); % R-G
    ImDiff(:,:,4) = ImLightOn(:,:,2)-ImLightOn(:,:,1); % G-R for verification
    ImDiff(:,:,5) = ImLightOn(:,:,3)-ImLightOn(:,:,1); % B-R
    ImDiff(:,:,6) = ImLightOn(:,:,1)-ImLightOn(:,:,3); % R-B for verification
ImDiff(:,:,7) = ImLightOn(:,:,2)-ImLightOn(:,:,3)-ImLightOn(:,:,1); % G-B-R Holes

%    for i=1:Rows
%        for j=1:Columns
%            if ImDiff(i,j,k) < 0
for k=1:7
if min(min(ImDiff(:,:,k))) < 0
ImDiff(:,:,k) = ImDiff(:,:,k)+abs(min(min(ImDiff(:,:,k))));
end
%            end %if
%        end %for j
%    end %for i
end %for k

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
YesPlot = 1
if YesPlot==1

figure
colormap(gray(255))
    subplot(2,2,1)
title('Original image')
    image(uint8(ImLightOn))
    grid
axis image
    subplot(2,2,2)
title('Red component')
    image(uint8(ImLightOn(:,:,1)))
axis image
    subplot(2,2,3)
title('Green component')
    image(uint8(ImLightOn(:,:,2)))
axis image
    subplot(2,2,4)
title('Blue component')
    image(uint8(ImLightOn(:,:,3)))
axis image

    
ImDiff=uint8(ImDiff);
    figure
    colormap(gray(255))
for k=1:7
    subplot(4,2,k)
    image(ImDiff(:,:,k))
    title([k])
    axis image
end % for k

figure
hist(double(ImDiff(:,:,1)))
title('Histogram of intensity levels for the Blue component')
grid

figure
hold on
title('Vertical image profiles for the Blue component')
plot(ImDiff(:,300,1),'g')
plot(ImDiff(:,400,1))
plot(ImDiff(:,500,1),'r')
legend('x=300','x=400','x=500')
grid

figure
hist(double(ImDiff(:,:,3)))
title('Histogram of intensity levels for the Red component')
grid

figure
hold on
title('Vertical image profiles for the Red component')
plot(ImDiff(:,300,3),'g')
plot(ImDiff(:,400,3))
plot(ImDiff(:,500,3),'r')
legend('x=300','x=400','x=500')
grid

figure
hold on
title('Horizontal image profiles for the Holes component')
plot(ImDiff(300,:,7),'g')
plot(ImDiff(400,:,7))
plot(ImDiff(550,:,7),'r')
legend('y=300','y=400','y=500')
grid

end % if YesPlot
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% line([0 1200], [mean(ImDiff(:,:,7)) ])

ThreshAsperitiesBlue = mean2(double(ImDiff(:,:,1))) + 1 * std2(double(ImDiff(:,:,1)))
ThreshAsperitiesRed = mean2(double(ImDiff(:,:,3))) + 1 * std2(double(ImDiff(:,:,3)))
ThreshHoles = mean2(ImDiff(:,:,7)) + 1 * std2(double(ImDiff(:,:,7)))

% hist(double(ImDiff(:,:,2))) % distribution of grays in Asperities

for i=1:Rows
    for j=1:Columns
    if ImDiff(i,j,1) > ThreshAsperitiesBlue % ThreshAsperities BLUE % 150 % 
        ImDiff(i,j,8) = 255; % Hooking areas
    end % if
    if ImDiff(i,j,3) > ThreshHoles % ThreshAsperitiesRed % ThreshAsperities RED % 150 % 
        ImDiff(i,j,9) = 255; % Hooking areas
    end % if
    if ImDiff(i,j,7) > ThreshHoles
        ImDiff(i,j,10) = 255; % Hole areas
    end % if
end %for j
end %for i

figure
image(ImDiff(:,:,8))
colormap(hot)
title('Blue asperities')
    axis image

figure
image(ImDiff(:,:,9))
colormap(hot)
title('Red asperities')
    axis image
    
figure
image(ImDiff(:,:,10))
colormap(hot)
title('Holes')
    axis image
    
figure
image(uint8(ImLightOn))
title('Original image')
axis image
grid

% BLUE LOOP
for i=1:Rows
    for j=1:Columns
        if ImDiff(i,j,8) == 255
            ImBlueLight(i,j,:) = [0 0 255];
            k = 2;
            while [i+k < Rows] & [ImDiff(i+k,j,10) == 255]
                k = k + 1;
            end % while
            ImBlueLight( i+1:i+k-1 ,j,1) = 255;
            ImBlueLight( i+1:i+k-1 ,j,2) = 255;
            ImBlueLight( i+1:i+k-1 ,j,3) = 0;
        end % if
    end %for j
end %for i

% RED LOOP
for i=1:Rows
    for j=1:Columns
        if ImDiff(i,j,9) == 255
            ImRedLight(i,j,:) = [255 0 0];
            k = - 10;
            while [i+k > 0] & [ImDiff(i+k,j,10) == 255]
                k = k - 1;
            end % while
            ImRedLight( :,j,1) = 255;
            ImRedLight( :,j,2) = 255;
            ImRedLight( :,j,3) = 0;

            ImRedLight( i+1:i+k+1 ,j,1) = 255;
            ImRedLight( i+1:i+k+1 ,j,2) = 255;
            ImRedLight( i+1:i+k+1 ,j,3) = 0;
        end % if
    end %for j
end %for i

figure
image(uint8(ImBlueLight))
title('Blue asperities and preceeding holes')
axis image
grid

figure
image(uint8(ImRedLight))
title('Red asperities and preceeding holes')
axis image
grid