% Calculating hooking statistics 
% Restrict the area to good lighting, good focus and no distortion (inner
% rectangle of size:
if Columns == 1280
ROIx = 160:800;
ROIy = 380:900;
ROIArea = (900-380+1)*(800-160+1);
elseif Columns == 640
ROIx = 80:400; % images from this batch have good quality all around
ROIy = 80:560;
ROIArea = (560-80+1)*(400-80+1);
%elseif Columns == 480 %light from the sides - transposed matrix
%ROIx = 80:560;
%ROIy = 80:400;
%ROIArea = (560-80+1)*(400-80+1);
elseif Columns == 480 %light from the sides - transposed matrix - take all image
ROIx = 80:560;
ROIy = 80:400;
ROIArea = (560-80+1)*(400-80+1);
else
    figure
    title('E R R O R image size not OK')
end

[HoleLabels, HoleNum] = bwlabeln (ImRedLight(ROIx,ROIy,1)); % label each hole from 1 to Num
%[HoleLabels, HoleNum] = bwlabeln (ImBlueLight(ROIx,ROIy,1)); % label each hole from 1 to Num

figure
image(HoleLabels) % show labelled holes for visual verification
title('Hole labels (shown by colour)')

stats = regionprops(HoleLabels,'Area'); % calculate area of each hole
for i=1:HoleNum
    HoleArea(i,1) = stats(i).Area; %   / ROIArea
end
% X=0:Num;

HoleAreaSort = sort(HoleArea);
% plot(HoleAreaSort)
j = 1;
i = 1;
while i <= HoleNum
    k = 1;
    while i<HoleNum & HoleAreaSort(i+k) == HoleAreaSort(i+k-1)
        k = k+1;
    end
    HoleAreaHist(j,1) = HoleAreaSort(i);
    HoleAreaHist(j,2) = k;
    j = j+1;
    i = i+k;
end
HoleAreaValues = j-1;

% sum(HoleAreaHist(:,2)) % for verification: this must be equal to HoleNum

Sum = 0;
for i=1:j-1
Sum = Sum + HoleAreaHist(i,1) .* HoleAreaHist(i,2);
end
% Sum % for verification: this must be equal to sum(HoleArea)
HoleAreaHist=sortrows(HoleAreaHist,1);

% Some relevant data about the surface
Number_of_Holes = HoleNum
Average_area = Sum / HoleNum
Max_hole_area = max(HoleAreaHist(:,1))

%plot(HoleAreaHist(:,1),cumsum(HoleAreaHist(:,1).*HoleAreaHist(:,2))/ROIArea*100)
%plot(HoleAreaHist(:,1).*HoleAreaHist(:,2)/ROIArea*100)
%title('')

% Area of useful asperities as a function of the tip size
for i=1:120 % tip size [square pixel]
%    k=i;
%while k
    UsefulSurf(i) = sum(  HoleAreaHist(i:HoleAreaValues,1).*HoleAreaHist(i:HoleAreaValues,2)/ROIArea*100  );
end
figure
plot(UsefulSurf)
grid
title('% of useful area')
xlabel('Spine/Claw tip diameter [pixels]')

%%%%%%%%%%%%%%%%%%%%%%%%% NOT IN USE
% Doing the same thing using the hist function (less accurate)
if YesPlot == 0
[AreaDist(1,:), AreaDist(2,:)] = hist(HoleArea, HoleNum); % look for size distribution of the HoleNum Holes. Conservatively look for HoleNum different values
% AreaDist(1,:) is the number of holes of size AreaDist(2,:), for a total of HoleNum values
% verification 
Sum = 0;
for i=1:HoleNum
Sum = Sum + AreaDist(1,i)*AreaDist(2,i);
end
Sum

100 * sum(HoleArea)/ROIArea % percentage of holes with respect to the surface

HoleAreaSort = sortrows(AreaDist',1); % sort in ascending order to exclude the size values with 0 occurrences
i=1;
while HoleAreaSort(i,1) == 0
    i = i+1;
end
AreaDist2 = HoleAreaSort(i:HoleNum,:) % cleaned matrix with occurrences of holes of same area AreaDist(2,:)
HoleAreaSort2 = sortrows(HoleAreaSort(i:HoleNum,:),2) % sort in ascending order again by the size of holes
plot(HoleAreaSort2)   %(i:HoleNum,2))

CumSizeDist = cumsum(SizeDist);
bar((Num-CumSizeDist))

bar(CumSizeDist)
end
%%%%%%%%%%%%%%%%%%%%%%%%% END NOT IN USE